/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 *  ianjuta-editor-search.h -- Autogenerated from libanjuta.idl
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef _IANJUTA_EDITOR_SEARCH_H_
#define _IANJUTA_EDITOR_SEARCH_H_

#include <glib-object.h>
#include <libanjuta/interfaces/ianjuta-editor-cell.h>
#include <libanjuta/interfaces/ianjuta-editor.h>

G_BEGIN_DECLS

#define IANJUTA_TYPE_EDITOR_SEARCH (ianjuta_editor_search_get_type ())
#define IANJUTA_EDITOR_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IANJUTA_TYPE_EDITOR_SEARCH, IAnjutaEditorSearch))
#define IANJUTA_IS_EDITOR_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IANJUTA_TYPE_EDITOR_SEARCH))
#define IANJUTA_EDITOR_SEARCH_GET_IFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), IANJUTA_TYPE_EDITOR_SEARCH, IAnjutaEditorSearchIface))

#define IANJUTA_EDITOR_SEARCH_ERROR ianjuta_editor_search_error_quark()

typedef struct _IAnjutaEditorSearch IAnjutaEditorSearch;
typedef struct _IAnjutaEditorSearchIface IAnjutaEditorSearchIface;


struct _IAnjutaEditorSearchIface {
	IAnjutaEditorIface g_iface;
	

	gboolean (*backward) (IAnjutaEditorSearch *obj, const gchar* search,  gboolean case_sensitive,  IAnjutaEditorCell* start,  IAnjutaEditorCell* end,  IAnjutaEditorCell** result_start,  IAnjutaEditorCell** result_end, GError **err);
	gboolean (*forward) (IAnjutaEditorSearch *obj, const gchar* search,  gboolean case_sensitive,  IAnjutaEditorCell* start,  IAnjutaEditorCell* end,  IAnjutaEditorCell** result_start,  IAnjutaEditorCell** result_end, GError **err);

};


GQuark ianjuta_editor_search_error_quark     (void);
GType  ianjuta_editor_search_get_type        (void);

gboolean ianjuta_editor_search_backward (IAnjutaEditorSearch *obj, const gchar* search,  gboolean case_sensitive,  IAnjutaEditorCell* start,  IAnjutaEditorCell* end,  IAnjutaEditorCell** result_start,  IAnjutaEditorCell** result_end, GError **err);

gboolean ianjuta_editor_search_forward (IAnjutaEditorSearch *obj, const gchar* search,  gboolean case_sensitive,  IAnjutaEditorCell* start,  IAnjutaEditorCell* end,  IAnjutaEditorCell** result_start,  IAnjutaEditorCell** result_end, GError **err);


G_END_DECLS

#endif
