/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 *  ianjuta-stream.c -- Autogenerated from libanjuta.idl
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

/**
 * SECTION:ianjuta-stream
 * @title: IAnjutaStream
 * @short_description: Implemented by plugins that can open file streams
 * @see_also: 
 * @stability: Unstable
 * @include: libanjuta/interfaces/ianjuta-stream.h
 * 
 */

#include "ianjuta-stream.h"
#include "libanjuta-iface-marshallers.h"

GQuark 
ianjuta_stream_error_quark (void)
{
	static GQuark quark = 0;
	
	if (quark == 0) {
		quark = g_quark_from_static_string ("ianjuta-stream-quark");
	}
	
	return quark;
}

/**
 * ianjuta_stream_open:
 * @obj: Self
 * @stream: Stream to open from.
 * @err: Error propagation and reporting
 *
 * The implementor opens the given stream.
 */
void
ianjuta_stream_open (IAnjutaStream *obj, FILE* stream, GError **err)
{
	g_return_if_fail (IANJUTA_IS_STREAM(obj));
	IANJUTA_STREAM_GET_IFACE (obj)->open (obj, stream, err);
}

/* Default implementation */
static void
ianjuta_stream_open_default (IAnjutaStream *obj, FILE* stream, GError **err)
{
	g_return_if_reached ();
}

static void
ianjuta_stream_base_init (IAnjutaStreamIface* klass)
{
	static gboolean initialized = FALSE;

	klass->open = ianjuta_stream_open_default;
	
	if (!initialized) {

		initialized = TRUE;
	}
}

GType
ianjuta_stream_get_type (void)
{
	static GType type = 0;
	if (!type) {
		static const GTypeInfo info = {
			sizeof (IAnjutaStreamIface),
			(GBaseInitFunc) ianjuta_stream_base_init,
			NULL, 
			NULL,
			NULL,
			NULL,
			0,
			0,
			NULL
		};
		type = g_type_register_static (G_TYPE_INTERFACE, "IAnjutaStream", &info, 0);
		g_type_interface_add_prerequisite (type, G_TYPE_OBJECT);
	}
	return type;			
}
